-module(catalogserver_tests).
-import(catalogserver,[start/0]).
-import(testing,[dotests/2,eqTest/3]).
-export([main/0, associate/3, lookup/2]).
main() -> dotests("catalogserver_tests $Revision: 1.3 $", tests()).
tests() -> compile:file(catalogserver),
    CS = start(), C2 = start(),  % make 2 catalog servers
    [eqTest(lookup(CS, take),"==",undefined), 
     eqTest(lookup(C2, quail),"==",undefined),
     begin associate(CS, take, took), 
	   associate(CS, keep, kept), 
	   eqTest(lookup(CS,take),"==",took)
     end,
     eqTest(lookup(CS,keep),"==",kept),
     begin associate(C2, quail, quails), 
	   associate(C2, duck, ducks), 
	   associate(C2, owl, owls), 
	   associate(C2, crow, crows), 
	   associate(C2, hawk, hawks),
	   eqTest(lookup(C2,quail),"==",quails)
     end,
     eqTest(lookup(C2,owl),"==",owls), 
     eqTest(lookup(C2,duck),"==",ducks),
     eqTest(lookup(CS,duck),"==",undefined),
     begin associate(CS, take,taking), 
	   associate(CS, keep,keeping), 
	   associate(C2, crow, murder), 
	   associate(C2, quail, covey), 
	   associate(C2, owl, parliment), 
	   eqTest(lookup(CS, take), "==", taking)
     end,
     eqTest(lookup(C2,owl), "==", parliment)      ].
% functions to help with testing, NOT for you to implement
-spec associate(CS::pid(), Key::any(), Value::any()) -> ok.
associate(CS, Key, Value) ->
    CS ! {self(), {associate, Key, Value}},
    receive {CS, ok} -> ok after 1000 -> wrong end.
-spec lookup(CS::pid(), Key::any()) -> any().
lookup(CS, Key) ->
    CS ! {self(), {lookup, Key}},
    receive {CS, {value_is, Value}} -> Value after 1000 -> wrong end.
	    
